// Global Variables
var kite = [];
var noOfKites = 0;
var maxKites = 4;

var turnLeft = [];
var turnRight = [];

var groundFromTop = 0.9;

var gameStart = true;
var gameEnd = false;
var playerKeys = [];
var forbiddenKeys = [];
var firstKey = true;

var impactPause = false;

var ripples = [];

var titleText = 'Bright:Night:Kite:Fight'

// 
var moonAndStars = new MoonAndStars();

var maxTime = 60;
var curTime = maxTime;
var counterTime;
var winner = [];
var noOfWinner = 0;
var highScore = 0;

// setup
var setUp = function(){
	context.textBaseline = 'middle';
}

// main game loops
var updateGame = function(){
	
	if(!impactPause){
	
		//console.log(myPads[0]);
		for(var i = 0; i < myPads.length; i++){
			//console.log(i, myPads[i]);
		}
	
		for(var i = 0; i < kite.length; i++){
			kite[i].groundCollision();
	
			kite[i].update();
			kite[i].updateTail();
			kite[i].updateClone();
		}
	
		// check for tail hits
		for(var i = 0; i < kite.length; i++){
			for(var j = 0; j < kite.length; j++){
				if(i != j){
					kite[i].hitTail(kite[j].getP(),j);
					kite[i].hitTail(kite[j].getCP(),j);
				}
			}
		}
		
		// update ripples
		for(var i = 0; i < ripples.length; i++){
			ripples[i].update();
		}
		
	}
	
	// moon and stars
	moonAndStars.update();
	
	// find player with highscores
	highScore = 0;
	for(var i = 0; i < kite.length; i++){
		if(kite[i].getPoints() > highScore){
			highScore = kite[i].getPoints();
		}
	}
	
	// set players with high scores as leaders
	for(var i = 0; i < kite.length; i++){
		if(kite[i].getPoints() == highScore){
			kite[i].setIsLeader(true);
		}
		else{
			kite[i].setIsLeader(false);
		}
	}
	
	
	// check for end game
	if(curTime < 0){
		gameEnd = true;
		clearInterval(counterTime);
		highScore = 0;
		
		// find winner
		for(var i = 0; i < kite.length; i++){
			if(kite[i].getPoints() > highScore){
				highScore = kite[i].getPoints();
			}
		}
		
		// check for draws
		noOfWinners = 0;
		
		for(var i = 0; i < kite.length; i++){
			if(kite[i].getPoints() == highScore){
				winner[winner.length] = i + 1;
				noOfWinners++;
			}
		}
	}
	
	fps.update();
	
}

var drawGame = function(){
	// refresh background
	context.beginPath();
	context.rect(0, 0, canvas.width, canvas.height);
	context.fillStyle = 'black';
	context.fill();
	
	moonAndStars.display();

	// display ripples
	for(var i = 0; i < ripples.length; i++){
		ripples[i].display();
	}
	
	// draw ground
	context.beginPath();
	context.beginPath();
	context.rect(-5, canvas.height*groundFromTop, canvas.width+5, canvas.height+5);
	context.fillStyle = 'rgba(0,0,30,1)';
	context.fill();
	
	for(var i = 0; i < kite.length; i++){
		kite[i].display();
	}
		
	// start bits
	if(gameStart || gameEnd){
		context.font = '60pt Calibri';
		context.fillStyle = 'rgba(255,255,225,1)';
		
		context.fillText(titleText, canvas.width/2 - (context.measureText(titleText).width/2), canvas.height*groundFromTop*0.5);
		context.font = '20pt Calibri';
		
		var l1Text = ' ';
		var l2Text = ' ';
		var l3Text = ' ';
		
		if(gameStart){
			if(firstKey){
				if(kite.length == 0){
					l1Text = 'Player ' + (kite.length + 1) + ' select your LEFT key.';
					l3Text = '(Press any key, this key will make your kite turn LEFT)';
				}
				else if(kite.length < maxKites){
					l1Text = 'Player ' + (kite.length + 1) + ' select your LEFT key.';
					l2Text = 'or'
					l3Text = 'Press ENTER to start ' + kite.length + ' player game.';
				}
				else{
					l3Text = 'Press ENTER to start ' + kite.length + ' player game.';
				}
			}
			else{
				l1Text = 'Player ' + (kite.length) + ' select your RIGHT key';
			}
		}
		if(gameEnd){
			if(noOfWinners == 1){
				l1Text = 'Player ' + winner[0] + ' wins.'
			}
			else if(noOfWinners == 2){
				l1Text = 'Players ' + winner[0] + ' & ' + winner[1] + ' draw.'
			}
			else if(noOfWinners == 3){
				l1Text = 'Players ' + winner[0] + ', ' + winner[1] + ' & ' + winner[2] + ' draw.'
			}
			else if(noOfWinners == 4){
				l1Text = 'Players ' + winner[0] + ', ' + winner[1] + ', ' + winner[2] + ' & ' + winner[3] + ' draw.'
			}
			
			l3Text = 'Press ENTER to restart game.'
		}	
		
		context.fillText(l1Text, canvas.width/2 - (context.measureText(l1Text).width/2), (canvas.height/2)+40);
		context.fillText(l2Text, canvas.width/2 - (context.measureText(l2Text).width/2), (canvas.height/2)+62);
		context.fillText(l3Text, canvas.width/2 - (context.measureText(l3Text).width/2), (canvas.height/2)+84);		
	}
	
	//fps.draw();
}

var resetGame = function(){
	gameStart = true;
	gameEnd = false;
    kite.splice(0,kite.length);
    forbiddenKeys.splice(0,forbiddenKeys.length);
    winner.splice(0,winner.length);
    noOfKites = 0;
    curTime = maxTime;
}


// input functions
function getMousePos(canvas, evt) {
    var rect = canvas.getBoundingClientRect();
    return {
        x: evt.clientX - rect.left,
        y: evt.clientY - rect.top
    };
}

canvas.addEventListener('mousemove', function(evt) {
    var mousePos = getMousePos(canvas, evt);
	mouseX = mousePos.x;
	mouseY = mousePos.y;
}, false);

document.addEventListener('keydown', function(event) {
    //console.log("keydown");
    var keyAlreadyTaken = false;
    
    if(gameStart){
		for(var i = 0; i < forbiddenKeys.length; i++){
			if(forbiddenKeys[i] == event.keyCode){
				keyAlreadyTaken = true;
				console.log("keyAlreadyTaken");
			}
		}
	
		if(event.keyCode == 13){ // start game
			if(firstKey && kite.length > 0){
				gameStart = false;
				counterTime = setInterval(function(){ curTime--;},1000);
			}
		}
		else if(!keyAlreadyTaken){
			if(firstKey){
				if(kite.length < maxKites){
					firstKey = false;
					console.log(kite.length);
					kite[kite.length] = new Kite(kite.length);
					kite[kite.length-1].setup();
					noOfKites++;
		
					turnLeft[kite.length-1] = false;
					turnRight[kite.length-1] = false;
			
					playerKeys[kite.length-1] = [];
					playerKeys[kite.length-1][0] = event.keyCode;
			
					// update kite positions
					for(var i = 0; i < kite.length; i++){
						kite[i].setStartX();
					}
					forbiddenKeys[forbiddenKeys.length] = event.keyCode;
				}
			}	
			else{
				playerKeys[kite.length-1][1] = event.keyCode;
				firstKey = true;
				forbiddenKeys[forbiddenKeys.length] = event.keyCode;
			}
			console.log(playerKeys[kite.length-1][0],playerKeys[kite.length-1][1]);
		}
    }
    else if(gameEnd){
    	if(event.keyCode == 13){ // start game
			resetGame();
		}
    }
    else{
    	for(var i = 0; i < kite.length; i++){
    		if(event.keyCode == playerKeys[i][0]){
    			//console.log(i,"turn left")
    			turnLeft[i] = true;
    		}
    		if(event.keyCode == playerKeys[i][1]){
    			//console.log(i,"turn right")
    			turnRight[i] = true;
    		}
    	}
    }
	
	//console.log(event.keyCode); // a is 65 -> z is 90
});

document.addEventListener('keyup', function(event) {
    //console.log("keyup");
    
    if(!gameStart && !gameEnd){
		for(var i = 0; i < kite.length; i++){
			if(event.keyCode == playerKeys[i][0]){
				turnLeft[i] = false;
			}
			if(event.keyCode == playerKeys[i][1]){
				turnRight[i] = false;
			}
		}
	}
    
	
	//console.log(event.keyCode); // a is 65 -> z is 90
});


// do not adjust below here

// from http://www.playmycode.com/blog/2011/08/building-a-game-mainloop-in-javascript/

var myPads = [];

var mainloop = function() {
	//updateGamePads();
    updateGame();
    drawGame(); 
};

var updateGamePads = function(){
	/// GAME PADS ////////////////
    var gamepads = navigator.getGamepads();

    for (var i = 0; i < gamepads.length; i++) // was ++i
    {
        if(gamepads[i] != null){
        	//console.log(gamepads[i].buttons[0])
        	myPads[i] = gamepads[i];
        	console.log(i,gamepads[i].id);
        }
    }
};
	
var animFrame = window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame    ||
    window.oRequestAnimationFrame      ||
    window.msRequestAnimationFrame     ||
    null ;

if ( animFrame !== null ) {
    //var canvas = document.getElementById('myCanvas');
	//var context = canvas.getContext('2d'); // <--------- I have added this

    var recursiveAnim = function() {
        mainloop();
        animFrame( recursiveAnim, canvas );
    };

	setUp(); // <----- I have added this
	
	// start the mainloop
    animFrame( recursiveAnim, canvas );
} else {
        var ONE_FRAME_TIME = 1000.0 / 60.0 ;
        setInterval( mainloop, ONE_FRAME_TIME );
}

var fps = {
	current: 0,
	last: 0,
	lastUpdated: Date.now(),
	
	draw: function(){
		context.fillStyle = 'white';
		context.fillRect(0,0,50,25);
		context.font = '12pt Arial';
		context.fillStyle = 'black';
		context.textBaseline = 'top';
		context.fillText(fps.last + 'fps', 5, 5);
	},
	update: function(){
		fps.current++;
		if(Date.now() - fps.lastUpdated >= 1000){
			fps.last = fps.current;
			fps.current = 0;
			fps.lastUpdated = Date.now();
		}
	}
}
	
// do not adjust before here
	
// do not adjust before here